// console_app.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "windows.h"

#include "..\static_dll\dllExport.h"

#include "..\dynamic_dll\dllExport.h"

#define FncStaticFnc FncDynamicFnc

int _tmain(int argc, _TCHAR* argv[])
{

   //
   // staticky
   //

   StaticFnc();

   //
   // dynamicky
   //

   //nactu knihovnu
   HMODULE dll_dyn = LoadLibrary(_T("dynamic_dll.dll"));

   if (dll_dyn != NULL)
   {

      FncDynamicFnc fnc = NULL;

      //nactu funkci
      fnc = (FncDynamicFnc)GetProcAddress(dll_dyn, "DynamicFnc");

      if (fnc != NULL)
      {
         //spustim funkci
         fnc();
      }

      //uvolnim knihovnu
      FreeLibrary(dll_dyn);
   }

   //
   // dynamicky statickou
   //

   //nactu knihovnu
   HMODULE dll_st = LoadLibrary(_T("static_dll.dll"));

   if (dll_st != NULL)
   {

      FncStaticFnc fnc = NULL;

      //nactu funkci
      fnc = (FncStaticFnc)GetProcAddress(dll_st, "?StaticFnc@@YAXXZ");

      if (fnc != NULL)
      {
         //spustim funkci
         fnc();
      }

      //uvolnim knihovnu
      FreeLibrary(dll_st);
   }
   return 0;
}

